import java.io.File;
import java.io.IOException;
import java.security.SecureRandom;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;

import org.apache.commons.codec.binary.Hex;


public class FDBCipher {
	//
	//Íݒt@C
	public static final String CIPHER_FILE="fdbcipher.txt";
	private static final String[] CIPHER_DEF=new String[]{"FDBApp.jar","block","ftHg","[g","ȍH[","http://www.takana.info/"};
	private static final int CIPHER_LINE_NAME=0;
	private static final int CIPHER_LINE_KEY=1;
	private static final int CIPHER_LINE_TITLE=2;
	private static final int CIPHER_LINE_AUTHER=3;
	private static final int CIPHER_LINE_INFO01=4;
	private static final int CIPHER_LINE_INFO02=5;
	//
	//Ăяo
	FDBFrame frame;
	FDBFileIO fileIO;
	//
	//ÖÍۑt@C
	File outFile=null;
	//ÍẼL[
	String key=null;
	//vCp̏
	String title=null;
	String auther=null;
	String info01=null;
	String info02=null;
	//
	//*************************************************************
	//
	//-------------------------------------------------------------
	public FDBCipher(FDBFrame frm,FDBFileIO fIO){
		//
		frame=frm;
		fileIO=fIO;
		//Jar̈Íݒt@C
		String[] data=fileIO.getFileStringInJar(CIPHER_FILE);
		if(data==null || data.length<CIPHER_LINE_AUTHER+1){
			data=CIPHER_DEF;
		}
		//Íۑt@CiJart@C̊gqς́j
		File file=fileIO.setSelfJarFile(data[CIPHER_LINE_NAME]);		//***FileIOJarFileZbgĂ***
		if(file!=null){		outFile=changeJarToStageFile(file);	}
		//L[
		key=data[CIPHER_LINE_KEY];
		//vCp̏
		title=data[CIPHER_LINE_TITLE];
		auther=data[CIPHER_LINE_AUTHER];
		if(data.length>=CIPHER_LINE_INFO01+1){
			info01=data[CIPHER_LINE_INFO01];
			if(data.length>=CIPHER_LINE_INFO02+1){
				info02=data[CIPHER_LINE_INFO02];
			}
		}
	}
	//giJart@Cj̊gqςāAÍۑt@Cɂ
	private static File changeJarToStageFile(File file){
		String path=file.getPath();
		String beforeExt=".jar";	//̊gq
		String afterExt=".dat";		//ύX̊gq
		//
		if(path.lastIndexOf(beforeExt)==path.length()-beforeExt.length()){
			return new File(path.substring(0,path.length()-beforeExt.length())+afterExt);
		}else{
			return null;
		}
	}
	//*************************************************************
	//Íݒt@C
	//-------------------------------------------------------------
	//ۑp̕쐬iÓIFJarój
	public static String getCipherFileString(String fileName,String title,String autherName,String info01,String info02){
		StringBuffer buf=new StringBuffer();
		//eiL[͎쐬j
		buf.append(fileName).append(FDBFileIO.BR);
		buf.append(makeKeyString(5)).append(FDBFileIO.BR);
		//vCp̏
		if(title.equals("")){
			buf.append(fileName).append(FDBFileIO.BR);
		}else{
			buf.append(title).append(FDBFileIO.BR);	//󗓂ł΃t@C
		}
		if(autherName.equals("")){
			buf.append("L").append(FDBFileIO.BR);
		}else{
			buf.append(autherName).append(FDBFileIO.BR);
			if(!info01.equals("")){	buf.append(info01).append(FDBFileIO.BR);	}
			if(!info02.equals("")){	buf.append(info02).append(FDBFileIO.BR);	}
		}
		//
		return buf.toString();
	}
	//vCp̃^Cg
	public String getTitle(){
		return title;
	}
	//vCp̃pY쐬҂̏
	public String getAuther(){
		StringBuffer buf=new StringBuffer();
		//
		buf.append(auther);
		if(info01!=null){
			buf.append(FDBFileIO.BR).append(FDBFileIO.BR).append(info01);
			if(info02!=null){
				buf.append(FDBFileIO.BR).append(info02);
			}
		}
		//
		return buf.toString();
	}
	//*************************************************************
	//BXe[WOۑivC[hŃXe[WI𐧌Ăꍇ̂݁j
	//-------------------------------------------------------------
	//j[
	public void deleteStageNum(){
		if(outFile==null){	return;	}
		//t@C폜Ńf[^
		outFile.delete();
	}
	//j[
	public boolean  saveStageNum(int stgNum){
		if(outFile==null){
			frame.showErrorDialog("Xe[Wۑt@C𓾂Ă܂");
			return false;
		}
		//Xe[WԍÍ
		String encrypted=encryptStageNum(stgNum);
		if(encrypted==null){
			frame.showErrorDialog("ÍɎs܂");
			return false;
		}
		//t@C쐬i㏑jŃf[^ۑ
		try{
			FDBFileIO.makeTextFile(outFile, encrypted);
			return true;
		}catch(IOException e){
			frame.showErrorDialog("Xe[Wۑt@C쐬Ɏs܂");
			return false;
		}
	}
	//pY쐬ɂ̂݃`FbNiInterfacegj
	public int loadStageNum(){
		if(outFile==null){	return 1;	}
		//Íꂽ
		String[] ret=FDBFileIO.getFileString(outFile);
		if(ret==null){	return 1;	}
		//Xe[Wԍ
		return decryptStageNum(ret[0]);
	}
	//*************************************************************
	//Xe[Wԍ̈ÍEinot staticj
	//-------------------------------------------------------------
	//Í
	public String encryptStageNum(int stgNum){
		if(key==null){	return null;	}
		//
		try{
			return encrypt(key,String.valueOf(stgNum));
		}catch(Exception e){
			return null;
		}
	}
	//𕜍
	public int decryptStageNum(String encripted){
		if(encripted==null){	return 1;	}
		if(key==null){	return 1;	}
		//
		try{
			return Integer.parseInt(decrypt(key,encripted));
		}catch(Exception e){
			return 1;
		}
	}
	//*************************************************************
	//ėpistaticj
	//-------------------------------------------------------------
	//Key쐬
	private static String makeKeyString(int size){
		SecureRandom random=new SecureRandom();
		//
		char[] key=new char[size];
		//
		for(int k=0;k<key.length;k++){
			switch(random.nextInt(3)){
			case 0:		//'a'-'z'
				key[k]=(char)(97+random.nextInt(26));
				break;
			case 1:		//'A'-'Z'
				key[k]=(char)(65+random.nextInt(26));
				break;
			case 2:		//'0'-'9'
				key[k]=(char)(48+random.nextInt(10));
				break;
			default:
				key[k]='a';
			}
		}
		//
		return new String(key);
	}
	//Í
	private static String encrypt(String key,String text) throws Exception{
		//iBlowfishŁj
		SecretKeySpec skSpec=new SecretKeySpec(key.getBytes(),"Blowfish");
		Cipher cipher=Cipher.getInstance("Blowfish");
		cipher.init(Cipher.ENCRYPT_MODE, skSpec);
		//ÍsioCgz񂪓j
		byte[] encrypted=cipher.doFinal(text.getBytes());
		//ÍꂽoCgz𕶎񉻁i˂Έꕔ̏񂪎炵j
		return new String(Hex.encodeHex(encrypted));			//OCu[gp
	}
	//
	private static String decrypt(String key,String text) throws Exception{
		//ÍꂽoCgz
		byte[] encrypted=Hex.decodeHex(text.toCharArray());		//OCu[gp
		//iBlowfishŁj
		SecretKeySpec skSpec=new SecretKeySpec(key.getBytes(),"Blowfish");
		Cipher cipher=Cipher.getInstance("Blowfish");
		cipher.init(Cipher.DECRYPT_MODE, skSpec);
		//s
		byte[] decrypted=cipher.doFinal(encrypted);
		//
		return new String(decrypted);
	}
}
