import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.JarURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import java.util.zip.ZipOutputStream;

import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
//import javax.swing.filechooser.FileNameExtensionFilter;


public class FDBFileIO extends Component {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//----------------------------------------------------
	//ƃtH_
	private static final String WORK_FOLDER="work";
	public static final String SE_FOLDER="se";
	public static final String BACK_FOLDER="back";
	public static final String SEP=System.getProperty("file.separator");
	public static final String BR=System.getProperty("line.separator");
	//{ݒt@C
	public static final String SET_FILE="fdbset.txt";
	private static final int[] SET_DATA_DEFAULT=new int[]{FDBFrame.RUN_EDIT,800,600,FDBFrame.SND_IN,FDBFrame.STG_SELECTABLE};
	public static final int SET_DATA_RUN=0;
	public static final int SET_DATA_WIDTH=1;
	public static final int SET_DATA_HEIGHT=2;
	public static final int SET_DATA_SOUND=3;
	public static final int SET_DATA_STAGE=4;
	//----------------------------------------------------
	//g܂܂JarFileiCipher̃\bhĂяoŎ擾j
	JarFile selfJarFile;
	//ƃtH_
	File workFolder;
	//
	FDBFrame frame;
	//
	File saveFile;
	//
	boolean changed;	//pY̐ݒ肪ύXĂijOɊmF̕Kvj
	//
	JFileChooser chooser=new JFileChooser();
	//*************************************************************
	//
	//-------------------------------------------------------------
	public FDBFileIO(FDBFrame frm){
		frame=frm;
		//
		workFolder=new File(System.getProperty("user.dir")+SEP+WORK_FOLDER);
		//
		saveFile=null;
		//
		changed=false;
	}
	//*************************************************
	//Framẽ^Cgp
	//-------------------------------------------------
	public String getFileName(){
		if(saveFile!=null){
			return saveFile.getName();
		}else{
			return "";
		}
	}
	//*************************************************************
	//Z[ut@Cf[^ύX
	//-------------------------------------------------------------
	public void changePuzzle(boolean newPuzzle){	//
		if(newPuzzle){	//VK쐬ȂZ[ut@Cj
			saveFile=null;
			frame.setTitleString();
		}
		changed=true;	//f[^ύX
	}
	public boolean needSave(){		//f[^jOɕKmF
		return changed;
	}
	//*************************************************************
	//{ݒt@C
	//-------------------------------------------------------------
	//t@C̏擾
	public int[] getSetInfo(boolean outFlag){
		String[] setStr;
		if(outFlag){
			setStr=getFileString(SET_FILE);			//worktH_
		}else{
			setStr=getFileStringInJar(SET_FILE);	//JARt@C
		}
		if(setStr==null || setStr.length<SET_DATA_DEFAULT.length){
			return SET_DATA_DEFAULT;		//擾e΃ftHgl
		}
		//ɒ
		int[] setInt=new int[SET_DATA_DEFAULT.length];
		for(int s=0;s<SET_DATA_DEFAULT.length;s++){
			try{
				setInt[s]=Integer.parseInt(setStr[s]);
			}catch(NumberFormatException e){
				setInt[s]=SET_DATA_DEFAULT[s];
			}
		}
		//
		return setInt;
	}
	//ƃtH_ɁAt@C쐬
	public void makeSetFile(int run,Dimension size,int snd,int stg){
		//
		String data=getSetFileString(run,size,snd,stg);
		//
		File setFile=getWorkFile(SET_FILE);
		try{
			makeTextFile(setFile,data);
		}catch(IOException e){
			frame.showErrorDialog("{ݒt@C̏o͂Ɏs܂"+FDBFileIO.BR+e.toString());
		}
	}
	//ۑp̕쐬iÓIFJarój
	public static String getSetFileString(int run,Dimension size,int snd,int stg){
		StringBuffer buf=new StringBuffer();
		buf.append(run).append(BR);
		buf.append(size.width).append(BR);
		buf.append(size.height).append(BR);
		buf.append(snd).append(BR);
		buf.append(stg).append(BR);
		//
		return buf.toString();
	}
	//*************************************************************
	//Xe[Wݒt@CAubNzut@C
	//-------------------------------------------------------------
	//p̃ftHgXe[Wݒt@C쐬
	public void makeFirstStageFile(int stg){
		//Xe[Wݒ肵ftHgݒ쐬
		FDBSetFile s0=new FDBSetFile(frame);
		s0.setDefaultData(new String[]{FDBSetFile.L_STAGE_MAX+"("+stg+")"});
		//t@CɏóiftHg0nj
		makeStageFile(0, s0.getFirstDefaultDataString());	//pɃXe[Ŵ݂̕
	}
	//ƃtH_ɁAXe[Wԍƃf[^w肵č쐬
	public void makeStageFile(int stgNum,String data){
		File file=getWorkFile(getTargetStageFileName(stgNum));
		//
		try{
			makeTextFile(file,data);
		}catch(IOException e){
			frame.showErrorDialog("Xe[Wݒt@C̏o͂Ɏs܂"+FDBFileIO.BR+e.toString());
		}
	}
	//ݒt@C̕f[^𓾂
	public String[] getStageData(int stgNum){
		String fileName=getTargetStageFileName(stgNum);
		String[] data=getFileString(fileName);
		if(data!=null){
			return data;
		}else{
			return new String[0];
		}
	}
	//tH_̃ubNzut@C܂Ƃ߂Ď荞
	public void copyBlockFiles(File folder,int stg){
		File beforeFile;
		for(int s=0;s<=stg;s++){
			beforeFile=new File(folder.getPath()+SEP+getTargetBlockFileName(s));
			if(beforeFile.exists()){
				copyBlockFile(s,beforeFile);
			}
		}
	}
	//̃ubNzut@C荞
	public void copyBlockFile(int stgNum,File beforeFile){
		File afterFile=getWorkFile(getTargetBlockFileName(stgNum));
		//
		try{
			copyFile(beforeFile,afterFile);
		}catch(IOException ioe){
			frame.showErrorDialog("ubNzut@C̃Rs[Ɏs܂"+FDBFileIO.BR+ioe.toString());
		}
	}
	//Xe[Wݒt@CƃubNzut@C폜iꍇj
	public void deleteStageFile(int stgNum){
		File file=getWorkFile(getTargetStageFileName(stgNum));
		//
		file.delete();
	}
	public void deleteBlockFile(int stgNum){
		File file=getWorkFile(getTargetBlockFileName(stgNum));
		//
		file.delete();
	}
	//]vȃXe[Wݒt@CƃubNzut@C폜iXe[W炵ꍇj
	public void deleteUselessStageBlockFiles(int stgNum){
		File fileS,fileB;
		for(int s=FDBFrame.STAGE_MAX;s>stgNum;s--){
			fileS=getWorkFile(getTargetStageFileName(s));
			fileB=getWorkFile(getTargetBlockFileName(s));
			//
			if(fileS.exists()){	fileS.delete();	}
			if(fileB.exists()){	fileB.delete();	}
		}
	}
	//Xe[Wԍݒt@C𓾂
	public static String getTargetStageFileName(int stgNum){
		if(stgNum>=100){
			return "s"+String.valueOf(stgNum)+".txt";
		}else if(stgNum>=10){
			return "s0"+String.valueOf(stgNum)+".txt";
		}else{
			return "s00"+String.valueOf(stgNum)+".txt";
		}
	}
	public static String getTargetBlockFileName(int stgNum){
		if(stgNum>=100){
			return "b"+String.valueOf(stgNum)+".csv";
		}else if(stgNum>=10){
			return "b0"+String.valueOf(stgNum)+".csv";
		}else{
			return "b00"+String.valueOf(stgNum)+".csv";
		}
	}
	//*************************************************************
	//yt@C
	//-------------------------------------------------------------
	//ƃtH_ƍ폜isvɂȂAVRs[Ă鎞j
	public void deleteSEFolder(){
		File seFolder=getWorkFile(SE_FOLDER);
		if(seFolder.exists()){
			deleteInnerFiles(seFolder,true);	//tH_폜
		}
	}
	//ǑʉRs[Ă
	public void copySEFiles(File dir,String ext){
		//Ô폜
		deleteSEFolder();
		//ʉtH_쐬
		File seFolder=getWorkFile(SE_FOLDER);
		seFolder.mkdirs();
		//t@CXɎw肵ăRs[Ă
		try{
			File beforeSE,afterSE;
			for(int s=0;s<FDBSound.SE_ALL;s++){
				beforeSE=new File(dir.getPath()+SEP+FDBSound.SOUND_NAME[s]+"."+ext);
				afterSE=new File(seFolder.getPath()+SEP+FDBSound.SOUND_NAME[s]+"."+ext);
				if(beforeSE.exists()){
					copyFile(beforeSE,afterSE);
				}else{		//ȂΓ̂őp
					if(selfJarFile!=null){
						outFromSelfJarToWork(SE_FOLDER+'/'+FDBSound.SOUND_NAME[s]+"."+ext);	//JARseparator'/'
					}
				}
			}
		}catch(IOException e){
			frame.showErrorDialog("ʉ̃Rs[Ɏs܂"+FDBFileIO.BR+e.toString());
		}
	}
	//*************************************************************
	//wi摜
	//-------------------------------------------------------------
	//摜witH_ɃRs[iݒt@Cۑ鎞j
	public void copyBackImage(File before){
		//tH_쐬
		File backFolder=getWorkFile(BACK_FOLDER);
		if(!backFolder.exists()){	backFolder.mkdirs();	}
		//Rs[
		File after=new File(backFolder.getPath()+SEP+before.getName());
		//
		try{
			copyFile(before,after);
		}catch(IOException ioe){
			frame.showErrorDialog("wi摜̃Rs[Ɏs܂"+FDBFileIO.BR+ioe.toString());
		}
	}
	//svɂȂ摜폜iݒ_CAOOj
	public void deleteUselessBackImages(int stg){
		//[vėp
		File file;
		//KvȔwi摜
		ArrayList<String> needImages=new ArrayList<String>();
		//Xe[Wݒt@CKvȉ摜擾
		FDBSetFile set=new FDBSetFile(frame);
		for(int s=0;s<=stg;s++){
			file=getWorkFile(getTargetStageFileName(s));	//Xe[Wݒt@C
			if(file.exists()){
				set.setDefaultData(getFileString(getTargetStageFileName(s)));	//sK؂Awi摜̂ݒׂ΂̂
				if(set.backImage!=null){
					needImages.add(changeImagePathToName(set.backImage));
				}
			}
		}
		//witH_svȉ摜폜
		File backFolder=getWorkFile(BACK_FOLDER);
		if(backFolder.exists()){
			String[] existImages=backFolder.list();		//݂摜
			for(int e=0;e<existImages.length;e++){
				if(checkImageUseless(existImages[e],needImages)){	//svłȂ폜
					file=new File(backFolder.getPath()+SEP+existImages[e]);
					file.delete();
				}
			}
			//tH_ɂȂĂtH_폜
			existImages=backFolder.list();
			if(existImages.length==0){
				backFolder.delete();
			}
		}
	}
	//̉摜͕Kv摜̃XgɊ܂܂ĂȂǂ
	private boolean checkImageUseless(String name,ArrayList<String> list){
		for(int n=0;n<list.size();n++){
			if(name.equals(list.get(n))){
				return false;	//܂܂Ă
			}
		}
		//Ō܂ŒׂĂ܂܂ĂȂ
		return true;
	}
	//ݒt@C̃pXƃt@CƂ̕ϊ
	public static String changeImagePathToName(String path){
		return path.substring(path.indexOf("/")+1);
	}
	public static String changeImageNameToPath(String name){
		return new String(BACK_FOLDER+"/"+name);
	}
	//*************************************************************
	//ƃtH_
	//-------------------------------------------------------------
	//ҏW[hŋNɏpỸf[^ƃtH_ɉ
	public void formatWorkFolder(){
		//tH_쐬
		File backFolder=getWorkFile(BACK_FOLDER);
		backFolder.mkdirs();
		//
		if(selfJarFile==null){
			frame.showErrorDialog("gJart@C𓾂Ă܂");
			return;
		}
		//
		try{
			outFromSelfJarToWork("fdbset.txt");				//{ݒ
			for(int s=0;s<=5;s++){
				outFromSelfJarToWork("s00"+s+".txt");		//Xe[Wݒ
				outFromSelfJarToWork("b00"+s+".csv");		//ubNzu
			}
			outFromSelfJarToWork(BACK_FOLDER+"/back.png");	//wi摜iJARseparator'/'j
		}catch(IOException ioe){
			frame.showErrorDialog("pYf[^̉𓀂Ɏs܂"+FDBFileIO.BR+ioe.toString());
		}catch(NullPointerException npe){ //selfJarɖړĨt@CȂ
			frame.showErrorDialog("pYf[^̉𓀂Ɏs܂"+FDBFileIO.BR+npe.toString());
		}
	}
	//selfJartargetƃtH_ɉ
	private void outFromSelfJarToWork(String targetName) throws IOException,NullPointerException{
		outFromJarToFolder(selfJarFile,targetName,workFolder);
	}
	//JARtarget̃tH_։𓀁iÓIFAppleto͂̌ʉȊOj
	public static void outFromJarToFolder(JarFile jarFile,String targetName,File folder) throws IOException,NullPointerException{
		outFromJarToFolder(jarFile,targetName,folder,targetName);
	}
	//𓀌ƐtargetႤꍇɑΉiÓIFAppleto͂̌ʉj
	public static void outFromJarToFolder(JarFile jarFile,String targetInJar,File folder,String targetInFolder) throws IOException,NullPointerException{
		JarEntry jarEntry=new JarEntry(targetInJar);
		File outFile=new File(folder.getPath()+SEP+targetInFolder);
		//
		File parent=outFile.getParentFile();
		if(!parent.exists()){	parent.mkdirs();	}
		//
		BufferedInputStream bis=new BufferedInputStream(jarFile.getInputStream(jarEntry));
		BufferedOutputStream bos=new BufferedOutputStream(new FileOutputStream(outFile));
		//
		int b;
		while((b=bis.read())!=-1){
			bos.write((byte)b);
		}
		//
		bis.close();
		bos.close();
	}
	//ƃtH_ƍ폜ivOIj
	public void deleteWorkFolder(){
		if(workFolder.exists()){
			deleteInnerFiles(workFolder,true);	//tH_폜
		}
	}
	//ƃtH_S폜iVK쐬̑OA[h̑Oj
	public void deleteWorkFiles(){
		deleteInnerFiles(workFolder,false);		//tH_͎c
	}
	//ƃtH_̃pX擾iAppletJaȑo͂łgj
	public File getWorkFile(String target){
		return new File(workFolder.getPath()+SEP+target);
	}
	//******************************************************************
	//g܂܂ANꂽJARt@CivO쒆͂ƊJĂ邱ƂɂȂj
	//------------------------------------------------------------------
	//t@CςĂΉł悤擾ZbgiCipherĂ΂A߂lCipherŎgj
	public File setSelfJarFile(String defFileName){
		try{
			ClassLoader classLoader=this.getClass().getClassLoader();
			URL classURL=classLoader.getResource(this.getClass().getName()+".class");	//NXɊgqt˂΂ȂȂ
			JarURLConnection jarConn=(JarURLConnection)classURL.openConnection();
			URL jarURL=jarConn.getJarFileURL();
			selfJarFile=new JarFile(jarURL.toURI().getPath());			//JarFileZbgirURIȂƃpX̋󔒕Ȃ悤j
			//
			return new File(jarURL.toURI().getPath());					//FileCipherɖ߂
		}catch(Exception e){	//g̓JAR𓾂ȂΒڎw
			try{
				selfJarFile=new JarFile(System.getProperty("user.dir")+SEP+defFileName);	//JarFileZbg
				return new File(System.getProperty("user.dir")+SEP+defFileName);			//FileCipherɖ߂
			}catch(IOException ioe){
				selfJarFile=null;	//
				return null;		//
			}
		}
	}
	//AppletJaȑo͂Ŏoɂ
	public JarFile getSelfJarFile(){
		return selfJarFile;
	}
	//vOIɕ
	public void closeSelfJarFile(){
		if(selfJarFile!=null){
			try{
				selfJarFile.close();
			}catch(IOException e){
				//ꂩI邾Ȃ̂ŏȂ
			}
		}
	}
	//Gg[̊gq𒲂ׂiAppletJaȑo͂Ŏoׂt@C𔻒fj
	public static boolean checkEntryExtention(JarEntry entry,String... extentions){
		String name=entry.getName();
		//
		for(int e=0;e<extentions.length;e++){
			if(name.lastIndexOf(extentions[e])==name.length()-extentions[e].length()){
				return true;
			}
		}
		//
		return false;
	}
	//******************************************************************
	//
	//------------------------------------------------------------------
	//_CAÕXgڂɕtݒL̈
	public String checkDefaultStageFileInWorkFolder(){			//ftHg̃Xe[Wݒt@C͒gŔit@C͏ɂj
		if(FDBSetFile.checkFirstDefaultData(getStageData(0))){
			return "i~j";
		}else{
			return "ij";
		}
	}
	public String checkFileInWorkFolder(String fileName){		//ȊO̓t@C̗LŔ
		File file=getWorkFile(fileName);
		if(file.exists()){
			return "ij";
		}else{
			return "i~j";
		}
	}
	//̃tH_Sɍ폜iċAĂяojiĂяotruewŎg폜j
	private static void deleteInnerFiles(File dir,boolean selfDeleteFlag){
		String[] list=dir.list();
		for(int l=0;l<list.length;l++){
			File file=new File(dir.getPath()+SEP+list[l]);
			if(file.isFile()){
				file.delete();
			}else{
				deleteInnerFiles(file,true);	//̃tH_͖ɍ폜
			}
		}
		//̃tH_g폜邩
		if(selfDeleteFlag){
			dir.delete();
		}
	}
	//PɃt@CcopyiÓIFAppletój
	public static boolean copyFile(File before,File after) throws IOException{
		//t@CmF
		if(!before.exists() || before.isDirectory()){
			return false;
		}
		if(after.isDirectory()){
			return false;
		}
		//copytH_mF
		File dir=after.getParentFile();
		if(!dir.exists()){
			if(!dir.mkdirs()){
				return false;
			}
		}
		//s
		BufferedInputStream bis = new BufferedInputStream(new FileInputStream(before));
		BufferedOutputStream bos=new BufferedOutputStream(new FileOutputStream(after));
		int b;
		while((b=bis.read())!=-1){
			bos.write((byte)b);
		}
		bis.close();
		bos.close();
		//
		return true;
	}
	//******************************************************************
	//Z[uA[h
	//------------------------------------------------------------------
	public void load(){
		File file=chooseFileOnLoad("ݒi[t@C(*.zip)J","J",saveFile/*,new FileNameExtensionFilter("ݒi[t@C(*.zip)","zip")*/);
		if(file!=null){
			//̃\tg̃Z[ut@Cł邩`FbN
			if(!checkOpenableFile(file)){
				frame.showErrorDialog("FullDirectionBlock̃Z[ut@Cł͂܂"+BR+file.getName());
				return;
			}
			//ȑO̐ݒS폜Ă
			deleteWorkFiles();
			//zipƃtH_ɉ
			zipToWork(file);
			//Z[ut@Ci[
			saveFile=file;
			//t[̃^CgύX
			frame.setTitleString();
			//
			changed=false;	//f[^ύX܂Ȃ
			//pYăX^[g
			frame.restartPuzzle(true);
		}
	}
	private static boolean checkOpenableFile(File file){	//̃\tg̃Z[ut@Cł邩
		try{
			ZipFile zipFile=new ZipFile(file);
			//
			boolean setFlag=false;
			boolean cipherFlag=false;
			//
			Enumeration enm=zipFile.entries();
			while(enm.hasMoreElements()){
				String entryName=((ZipEntry)enm.nextElement()).getName();
				if(entryName.equals(SET_FILE)){
					setFlag=true;
				}else if(entryName.equals(FDBCipher.CIPHER_FILE)){
					cipherFlag=true;
				}
			}
			//ZIP̒Ɂu{ݒt@CvuÍt@CvȂ΁AZ[ut@Cł
			if(setFlag && !cipherFlag){
				return true;
			}else{
				return false;
			}
		}catch(IOException e){
			return false;
		}
	}
	public void save(){
		if(saveFile!=null){
			savePuzzleData(saveFile);	//s
		}else{	//Z[ut@C񂪂ȂΖOtĕۑ
			saveAs();
		}
	}
	public void saveAs(){
		File file=chooseFileOnSave("ݒi[t@C(*.zip)ɕۑ","ۑ",saveFile,/*new FileNameExtensionFilter("ݒi[t@C(*.zip)","zip")*/"zip");
		if(file!=null){
			savePuzzleData(file);
		}
	}
	private void savePuzzleData(File file){
		//ƃtH_zipɈk
		workToZip(file);
		//Z[ut@Ci[i㏑Ȃsvj
		saveFile=file;
		//t[̃^CgύXi㏑Ȃsvj
		frame.setTitleString();
		//
		changed=false;	//f[^ύXȂȂ
	}
	//******************************************************************
	//ƃtH_̒gZIPɈkiZ[uj
	//------------------------------------------------------------------
	public void workToZip(File fileZip){
		try {
			//ZIP̓}jtFXgȂ
			ZipOutputStream zos=new ZipOutputStream(new BufferedOutputStream(new FileOutputStream(fileZip)));
			//
			filesToZip(workFolder,zos);
			//
			zos.close();
		} catch (IOException ioe) {
			frame.showErrorDialog("Z[uiZIPkjɎs܂"+BR+ioe.toString());
		}
	}
	//w肳ꂽtH_ȉɂSt@CZIPɏށiċAĂяoj
	private void filesToZip(File outFolder,ZipOutputStream zos) throws IOException{
		String[] outFilesList=outFolder.list();
		//
		File outFile;
		for(int f=0;f<outFilesList.length;f++){
			outFile=new File(outFolder.getPath()+SEP+outFilesList[f]);	//΃pX
			//
			if(outFile.isFile()){				//t@CȂ珑
				fileToZipEntry(outFile,zos);
			}else if(outFile.isDirectory()){	//tH_ȂċAĂяo
				filesToZip(outFile,zos);
			}
		}
	}
	//w肳ꂽt@CZIPɏ
	private void fileToZipEntry(File outFile,ZipOutputStream zos) throws IOException{
		BufferedInputStream bis=new BufferedInputStream(new FileInputStream(outFile));
		//Gg[ǉi΃pX𑊑΃pXɏCj
		ZipEntry outEntry=new ZipEntry(outFile.getPath().substring(workFolder.getPath().length()+1));	//+1̓Zp[^[̕
		zos.putNextEntry(outEntry);
		//
		int b;
		while((b=bis.read())!=-1){
			zos.write((byte)b);
		}
		//
		zos.closeEntry();
		bis.close();
	}
	//******************************************************************
	//ZIPƃtH_ɉ𓀁i[hj
	//------------------------------------------------------------------
	public void zipToWork(File fileZip){
		try {
			ZipFile zipFile=new ZipFile(fileZip);
			//
			Enumeration enm=zipFile.entries();
			while(enm.hasMoreElements()){
				ZipEntry zipEntry=(ZipEntry)enm.nextElement();
				zipEntryToFile(zipFile,zipEntry);
			}
			//
			zipFile.close();
		} catch (IOException ioe) {
			frame.showErrorDialog("[hiZIP𓀁jɎs܂"+BR+ioe.toString());
		}
	}
	private void zipEntryToFile(ZipFile zipFile,ZipEntry zipEntry) throws IOException{
		File outFile=getWorkFile(zipEntry.getName());	//΃pX
		//
		if(outFile.isDirectory()){	//fBNgȂtH_쐬̂
			outFile.mkdirs();
		}else{						//t@CȂtH_쐬iKvȂjăt@Co
			//t@Ci[tH_܂݂ȂȂ̂ō쐬
			File parentFolder=new File(outFile.getParent());
			parentFolder.mkdirs();
			//
			BufferedInputStream bis=new BufferedInputStream(zipFile.getInputStream(zipEntry));
			BufferedOutputStream bos=new BufferedOutputStream(new FileOutputStream(outFile));
			//
			int b;
			while((b=bis.read())!=-1){
				bos.write((byte)b);
			}
			//
			bis.close();
			bos.close();
		}
	}
	//*************************************************************
	//ʉ擾iInterfacẽ\bhĂ΂j
	//-------------------------------------------------------------
	public AudioClip getSoundFile(String target,boolean outFlag){
		if(outFlag){	//ƃtH_
			File soundFile=getWorkFile(target);	//targetŊsetH_w肵Ă
			if(soundFile.exists()){
				try{
					return Applet.newAudioClip(soundFile.toURI().toURL());
				}catch(MalformedURLException exception){
					//G[ȂΓ̂g
					return Applet.newAudioClip(getClass().getResource(target));
				}
			}else{	//t@CȂΓ̂g
				return Applet.newAudioClip(getClass().getResource(target));
			}
		}else{			//JAR
			return Applet.newAudioClip(getClass().getResource(target));
		}
	}
	//*************************************************************
	//摜擾iInterfacẽ\bhĂ΂j
	//-------------------------------------------------------------
	public Image getImageFile(String target,boolean outFlag){
		if(outFlag){	//ƃtH_
			Image image=Toolkit.getDefaultToolkit().getImage(workFolder.getPath()+SEP+target);
			//擾҂
			MediaTracker mt=new MediaTracker(this);
			mt.addImage(image,0);
			try{
				mt.waitForID(0);
			}catch(InterruptedException e){
				return null;
			}
			//
			return image;
		}else{			//JAR
			return (new ImageIcon(getClass().getResource(target))).getImage();
		}
	}
	//*************************************************************
	//t@C̃pX擾iprɉ3ށj
	//-------------------------------------------------------------
	//o͐̃t@CIԏꍇ
	public File chooseFileOnSave(String title,String button,File path,/*FileNameExtensionFilter filter*/String... extension){
		//
		chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		//
		if(path!=null){
			chooser.setSelectedFile(path);
		}else{
			chooser.setSelectedFile(new File(System.getProperty("user.dir")+SEP+"."));
		}
		//
		/*
		chooser.resetChoosableFileFilters();
		if(filter!=null){
			chooser.addChoosableFileFilter(filter);
		}
		*/
		//
		chooser.setDialogTitle(title);
		//
		int ret=chooser.showDialog(frame, button);
		if(ret==JFileChooser.APPROVE_OPTION){
			File f=chooser.getSelectedFile();
			/*
			if(filter!=null){	//o͐̏ꍇ͎Ŋgqt
				f=addExtension(f,filter.getExtensions());
			}*/
			if(extension.length>0){
				f=addExtension(f,extension);
			}
			return f;
		}else{
			return null;
		}
	}
	//͌̃t@CIԏꍇ
	public File chooseFileOnLoad(String title,String button,File path/*,FileNameExtensionFilter filter*/){
		//
		chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		//
		if(path!=null){
			chooser.setSelectedFile(path);
		}else{
			chooser.setSelectedFile(new File(System.getProperty("user.dir")+SEP+"."));
		}
		//
		/*
		chooser.resetChoosableFileFilters();
		if(filter!=null){
			chooser.addChoosableFileFilter(filter);
		}
		*/
		//
		chooser.setDialogTitle(title);
		//
		int ret=chooser.showDialog(frame, button);
		if(ret==JFileChooser.APPROVE_OPTION){
			File f=chooser.getSelectedFile();
			if(f.exists()){
				return f;
			}else{			//͌̏ꍇ͎݂t@CłȂ΂ȂȂ
				frame.showErrorDialog("݂Ȃt@Cł");
				return null;
			}
		}else{
			return null;
		}
	}
	//tH_Iԏꍇ
	public File chooseFolder(String title,String button,File path){
		//
		chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		//
		if(path!=null){
			chooser.setSelectedFile(path);
		}else{
			chooser.setSelectedFile(new File(System.getProperty("user.dir")+SEP+"."));
		}
		//
		chooser.resetChoosableFileFilters();
		//
		chooser.setDialogTitle(title);
		//
		int ret=chooser.showDialog(frame, button);
		if(ret==JFileChooser.APPROVE_OPTION){
			return chooser.getSelectedFile();
		}else{
			return null;
		}
	}
	//t@CɎw肳ꂽgqtĂȂΕt
	private static File addExtension(File file,String... extension){
		//gqmF
		int period=file.getPath().lastIndexOf(".");
		if(period!=-1){
			for(int e=0;e<extension.length;e++){
				if(file.getPath().substring(period).equals("."+extension[e])){
					return file;	//̊gqtĂ
				}
			}
			//w肳ꂽgqǂtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}else{	//ŏ牽̊gqtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}
	}
	//*************************************************************
	//eLXgo
	//-------------------------------------------------------------
	//eLXgf[^t@CɕۑiÓIFAppletDialogWeby[WóACipher̓BXe[WOۑj
	public static boolean makeTextFile(File file,String data) throws IOException{
		//f[^mF
		if(data==null){
			return false;
		}
		if(file.isDirectory()){
			return false;
		}
		//o͐tH_mF
		File dir=file.getParentFile();
		if(!dir.exists()){
			if(!dir.mkdirs()){
				return false;
			}
		}
		//s
		PrintWriter pw=new PrintWriter(new BufferedWriter(new FileWriter(file)));
		pw.print(data);
		pw.close();
		//
		return true;
	}
	//w肳ꂽeLXgt@CǂݍœeԂ(Jar)
	public String[] getFileStringInJar(String fileOrder) {
		try{
			//jar̃eLXgt@C̓̓Xg[𓾂
			InputStream is=getClass().getResourceAsStream(fileOrder);	//̃NX璼ړǂݍ
			//StreamiÂnjReaderiVnj֕ϊ
			BufferedReader br=new BufferedReader(new InputStreamReader(is));
			//
			ArrayList<String> array=new ArrayList<String>();
			String str;
			while( (str=br.readLine())!=null ){
				array.add(str);
			}
			//
			br.close();
			//
			String[] ret=new String[array.size()];
			for(int i=0;i<ret.length;i++){
				ret[i]=array.get(i);
			}
			//
			return ret;
		}catch(IOException ioe){
			return null;
		}catch(NullPointerException npe){	//selfJarɖړĨt@CȂ
			return null;
		}
	}
	//w肳ꂽeLXgt@CǂݍœeԂiworktH_j
	public String[] getFileString(String fileOrderInWork){
		File file=getWorkFile(fileOrderInWork);
		//
		return getFileString(file);
	}
	//̃t@Cǂݍ݁iÓIFCipher̈Íݒt@Cj
	public static String[] getFileString(File file){
		if(!file.exists()){
			return null;
		}
		//
		try{
			ArrayList<String> stringArray=new ArrayList<String>();
			String line;
			//
			BufferedReader br=new BufferedReader(new FileReader(file));
			while((line=br.readLine())!=null){
				stringArray.add(line);
			}
			br.close();
			//
			String[] ret=new String[stringArray.size()];
			for(int i=0;i<stringArray.size();i++){
				ret[i]=stringArray.get(i);
			}
			return ret;
		}catch(IOException ioe){
			return null;
		}
	}
}
