//*************************************************************
//
//@@@@@@@@@@@SubN
//	@@@@@@@@u@FullDirectionBlock@v
//@@@@@@@@@@@@@version 1.1
//
//@@@@@@@@@@@@ҁF[g؁@@@
//@@@@@@@@@@쐬JnFQOOT^P
//@@@@@@@@@@ŏIXVFQOPO^U    [TN072/J62]
//*************************************************************

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.ArrayList;

import javax.swing.JPanel;
import javax.swing.JScrollPane;

//CNX
public class FDBPanel extends JPanel implements Runnable,MouseListener,MouseMotionListener,KeyListener, ComponentListener
{
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//-------------------------------------------
	//stateMode
	static final int S_START=0;
	static final int S_MOVE=1;
	static final int S_WAIT=2;
	static final int S_MOUSE_OUT=3;
	static final int S_REST=4;
	static final int S_CLEAR=5;
	static final int S_ALL_CLEAR=6;
	static final int S_OVER=7;
	//`p̍WP
	static final int U5=5;
	static final int U15=15;
	static final int U75=75;
	//
	private static final int REPAINT_INTERVAL=50;
	//-------------------------------------------
	//
	FDBPanelListener parent;
	//`p
	int wallThick;
	int baseX,baseY;
	int cornerX,cornerY;
	int fieldWidth,fieldHeight;
	int timerWidth;
	//݂̏
	int stateMode;
	//-------------------------------------------
	//
	FDBStageLoader stage;
	//
	FDBGeneral general;
	//
	FDBItemManager items;
	//
	FDBBars bars;
	//
	FDBBall ball;
	ArrayList<FDBBall> divideBallVec;	//{[ACeɂ葝{[
	//
	FDBBlocks blocks;
	//
	FDBImageSupply imageSupply;
	//
	FDBSound sounds;
	//-------------------------------------------
	//͔_
	Point repelPoint;
	//Xbh֌W
    Thread moveThread;
	boolean speedUpFlag;	//CtrlL[ɂꎞXs[hAbv
	boolean threadStop;
	//tHgݒ
	Font largeFont=new Font( "Dialog.plain", Font.BOLD, 3*U15);
	Font middleFont=new Font( "Dialog.plain", Font.BOLD, 2*U15);
	Font smallFont=new Font( "Dialog.plain", Font.BOLD, U15);
	//fobO[h
	boolean debugFlag;
	//
	//t[TCŶ
	JScrollPane scrollEdge;
	Dimension edgeMargin;
	//****************************************************************************
	//
	//----------------------------------------------------------------------------
	public FDBPanel(FDBPanelListener listener,Dimension puzzleSize){
		parent=listener;
		//
		wallThick=U5;
		baseX=U15;
		baseY=U75;
		//
		//pY쐬
		makePuzzle(puzzleSize);
		//ʏ͏\J[\
		setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
		//
		//Cxg
		addMouseListener(this);
		addMouseMotionListener(this);
		addKeyListener(this);
		addComponentListener(this);
	}
	//VȐݒŃpY쐬ȂiݒύXɌĂ΂j
	public void makePuzzle(Dimension puzzleSize){
		cornerX=puzzleSize.width-U15;
		cornerY=puzzleSize.height-3*U15;
		fieldWidth=puzzleSize.width-2*U15;
		fieldHeight=puzzleSize.height-U75-3*U15;
		timerWidth=(int)( (puzzleSize.width-2*U15)*2 / ((FDBItem.I_TIME_MAX*3)*3) );
		setPreferredSize(puzzleSize);
		//
		stateMode=S_START;
		//-------------------------------------------
		//N͂܂
		stage=new FDBStageLoader(parent);
		//
		general=new FDBGeneral(stage,parent);
		//
		items=new FDBItemManager(stage);
		//
		bars=new FDBBars(stage);
		bars.setBarsPosition(0,0,fieldWidth,fieldHeight);
		//
		ball=new FDBBall(stage);
		ball.setBallPosition(fieldWidth,fieldHeight,bars);
		divideBallVec=new ArrayList<FDBBall>();
		//
		blocks=new FDBBlocks(stage,fieldWidth,fieldHeight);
		//
		imageSupply=new FDBImageSupply(stage,ball,bars,parent);
		//Ōʉ[h
		sounds=new FDBSound(parent);
		//-------------------------------------------
		//
		repelPoint=null;
		//
		speedUpFlag=false;
		//fobO[h̃tOݒ
		if(parent.getParam("debug", "off").equals("on")){
			setDebug(true);
		}else{
			setDebug(false);
		}
		//`挴_Đݒ
		setPaintBasePoint();
	}
	//*******************************************
	//
	//-------------------------------------------
	//fobO[hwiFramẽj[Ă΂j
	public void setDebug(boolean f){
		debugFlag=f;
		repaint();
	}
	//Xe[W
	public int getStageMax(){
		return general.getStageMax();
	}
	//Xe[W̃ftHgݒ
	public FDBSetFile getDefaultSetting(){
		return stage.s0;
	}
	//BXe[WiOt@Cւ̕ۑŎgj
	public int getReachedStage(){
		return general.reachedMaxStage;
	}
	//傫ȏOɃXbh~߂
	public void pauseIfRuning(){
		if(stateMode==S_MOVE || stateMode==S_MOUSE_OUT){
			stateMode=S_REST;
			stopThread();	//vCĂŒł΋xeɂ
			//
			//repaint();
		}
	}
	//*********************************
	//{[ACe̔
	//---------------------------------
	public void operateBallNumFromItem(int all){
		if(divideBallVec.size()>0){	return;	}	//ȑO̕{[cĂȂ炵Ȃ
		//
		divideBallVec=new ArrayList<FDBBall>();
		for(int b=0;b<all;b++){
			divideBallVec.add(new FDBBall(ball,all,b));
		}
	}
	//**********************************************************
	//Z[uE[hAXe[WIiJavaScriptĂяoj
	//----------------------------------------------------------
	//Xe[WIitrueԂj
	public boolean selectStagePart(int num,String sMax){
		//w\ȍōXe[W߂
		int iMax;
		try{	//CookieɕۑĂf[^
			iMax = Integer.parseInt(sMax);
		}catch(NumberFormatException e){
			iMax = general.stageStart;
		}
		if(iMax>general.stageMax){
			iMax=general.stageMax;
		}
		if(iMax<general.reachedMaxStage){	//vO̍ōBXe[W
			iMax=general.reachedMaxStage;
		}
		//Ȏw肾
		if(num</*general.stageStart*/1 || num>iMax){	return false;	}	//JnXe[WȑOIׂȂĂ͂Ȃ낤
		//
		return goSelectedStage(num);
	}
	public boolean selectStageAll(int num){
		//Ȏw肾
		if(num</*general.stageStart*/1 || num>general.stageMax){	return false;	}	//JnXe[WȑOIׂȂĂ͂Ȃ낤
		//
		return goSelectedStage(num);
	}
	private boolean goSelectedStage(int num){
		//
		stopThread();		//XbhI
		prepareStage(num);
		//
		repaint();
		//
		return true;
	}
	//Z[ui3̃f[^Z[upɓnj
	public String getSaveDataStage(){
		goNextStageToSave();
		return String.valueOf(general.stageNow);
	}
	public String getSaveDataScore(){
		goNextStageToSave();
		return String.valueOf(general.stageStartScore);
	}
	public String getSaveDataLife(){
		goNextStageToSave();
		return String.valueOf(ball.stageStartCount);
	}
	public void goNextStageToSave(){	//uNAʂŃZ[uƂ̃Xe[W̎n߂̃f[^ŃZ[uv̂h
		if(stateMode==S_CLEAR){	//NAς݂Ȃ玟̃Xe[Wɐi߂ĂiJARo͂̂œBXe[WۑOɂgj
			prepareStage(FDBGeneral.O_NEXT);
			repaint();
		}
	}
	//[hitrueԂj
	public boolean setSaveData(String sStage,String sScore,String sLife){
		//
		int iStage,iScore,iLife;
		//
		try{
			iStage = Integer.parseInt(sStage);
			iScore = Integer.parseInt(sScore);
			iLife = Integer.parseInt(sLife);
		}catch(NumberFormatException e){
			return false;
		}
		//Ȏw肾
		if(iStage</*general.stageStart*/1 || iStage>general.stageMax){		//JnXe[WȑOIׂȂĂ͂Ȃ낤
			return false;
		}
		//stage
		stopThread();		//XbhI
		prepareStage(iStage);
		//scorelife͌ʂɓĂ͂߁iD܂Ȃj
		general.score=iScore;
		general.stageStartScore=iScore;
		ball.count=iLife;
		ball.stageStartCount=iLife;
		//
		repaint();
		//
		return true;
	}
	//******************************************************************************************************
	//`
	//------------------------------------------------------------------------------------------------------
	public void paintComponent(Graphics g){
		super.paintComponent(g);	//KviꂪȂƔwiFœhԂȂj
		//tB[h̔wi
		g.setColor(stage.s1.backColor);
		g.fillRect(baseX,baseY,fieldWidth,fieldHeight);	//wi摜ĂhiGIFȂǂւ̑Ήj
		if (imageSupply.backImage != null){
			//wi摜^Cɕ~l߂
			for(int h=0;h<=fieldHeight/imageSupply.backHeight;h++){
				for(int w=0;w<=fieldWidth/imageSupply.backWidth;w++){
					g.drawImage(imageSupply.backImage,baseX+w*imageSupply.backWidth,baseY+h*imageSupply.backHeight,this);
				}
			}
		}
		//block
		if(items.effectiveItemArr[FDBItem.I_TIME_MONO_BLOCKVIEW]==null){
			for(int h=0;h<blocks.horizontalNum;h++){
				for(int v=0;v<blocks.verticalNum;v++){
					if(blocks.checkBlockBeing(h,v)){
						g.drawImage(imageSupply.blockImages[blocks.blockColor[h][v]][blocks.blockResistNow[h][v]-1],baseX+blocks.cornerX[h],baseY+blocks.cornerY[v],blocks.cornerX[h+1]-blocks.cornerX[h],blocks.cornerY[v+1]-blocks.cornerY[v],this);
					}
				}
			}
		}
		//bar
		if(!bars.directionFlag[FDBBars.D_LEFT]){
			g.drawImage(imageSupply.barImage,baseX+bars.barOverhang-2*bars.barRadius,baseY+bars.barPosY-bars.barRadius,2*bars.barRadius,2*bars.barRadius,this);
		}
		if(!bars.directionFlag[FDBBars.D_UP]){
			g.drawImage(imageSupply.barImage,baseX+bars.barPosX-bars.barRadius,baseY+bars.barOverhang-2*bars.barRadius,2*bars.barRadius,2*bars.barRadius,this);
		}
		if(!bars.directionFlag[FDBBars.D_RIGHT]){
			g.drawImage(imageSupply.barImage,cornerX-bars.barOverhang,baseY+bars.barPosY-bars.barRadius,2*bars.barRadius,2*bars.barRadius,this);
		}
		if(!bars.directionFlag[FDBBars.D_DOWN]){
			g.drawImage(imageSupply.barImage,baseX+bars.barPosX-bars.barRadius,cornerY-bars.barOverhang,2*bars.barRadius,2*bars.barRadius,this);
		}
		//ball
		if(items.effectiveItemArr[FDBItem.I_TIME_MONO_THROUGH]!=null){
			g.setColor(Color.yellow);
			for(int r=4;r>=3;r--){
				g.drawOval(baseX+ball.posX-ball.radiusNow-r,baseY+ball.posY-ball.radiusNow-r,2*ball.radiusNow+2*r,2*ball.radiusNow+2*r);
			}
		}
		g.drawImage(imageSupply.ballImage,baseX+ball.posX-ball.radiusNow,baseY+ball.posY-ball.radiusNow,2*ball.radiusNow,2*ball.radiusNow,this);
		//{[ACe
		for(int b=0;b<divideBallVec.size();b++){
			FDBBall dBall=(FDBBall)(divideBallVec.get(b));
			if(items.effectiveItemArr[FDBItem.I_TIME_MONO_THROUGH]!=null){
				g.setColor(Color.yellow);
				for(int r=4;r>=3;r--){
					g.drawOval(baseX+dBall.posX-dBall.radiusNow-r,baseY+dBall.posY-dBall.radiusNow-r,2*dBall.radiusNow+2*r,2*dBall.radiusNow+2*r);
				}
			}
			g.drawImage(imageSupply.ballImage,baseX+dBall.posX-dBall.radiusNow,baseY+dBall.posY-dBall.radiusNow,2*dBall.radiusNow,2*dBall.radiusNow,this);
		}
		//item
		for(int i=0;i<items.flyingItemVec.size();i++){
			FDBItem fItem=(FDBItem)(items.flyingItemVec.get(i));
			g.drawImage(imageSupply.itemImages[fItem.typeAll][fItem.typePair],baseX+fItem.posX-11,baseY+fItem.posY-11,this);
		}
		//tB[hOwFœhԂ
		g.setColor(Color.gray);
		g.fillRect(0,0,getSize().width,baseY);
		g.fillRect(0,cornerY,getSize().width,getSize().height-cornerY);
		g.fillRect(0,baseY,baseX,fieldHeight);
		g.fillRect(cornerX,baseY,getSize().width-cornerX,fieldHeight);
		//ACe쓮c莞
		g.setFont(smallFont);
		for(int t=0;t<FDBItem.I_TIME_MAX;t++){
			g.setColor(Color.white);
			g.drawString(FDBItem.timerString[t],cornerX-3*(t+1)*timerWidth,cornerY+4*U5);
			g.setColor(Color.darkGray);
			g.fillRoundRect(cornerX-3*(t+1)*timerWidth,cornerY+5*U5,2*timerWidth,3*U5,U5,U5);
			g.setColor(items.getTimerPaintColor(t));
			g.fillRoundRect(cornerX-3*(t+1)*timerWidth,cornerY+5*U5,items.getTimerPaintWidth(t,2*timerWidth),3*U5,U5,U5);
		}
		//\iXe[WA_Ac胉Ctj
		g.setFont(largeFont);
		g.setColor(Color.orange);
		g.drawString("stage "+general.stageNow,baseX+U15,baseY-2*U15);
		g.setFont(middleFont);
		g.setColor(Color.white);
		String s="score : "+general.score;
		g.drawString(s,cornerX-2*U15-(int)(s.length()*middleFont.getSize()/2),baseY-U15);
		g.drawString("life : "+ball.getCountString(),baseX+2*U15,cornerY+2*U15);
		//
		//WALL
		if(bars.directionFlag[FDBBars.D_UP]){
			g.setColor(Color.lightGray);
			g.fillRoundRect(baseX-U5,baseY-U5,fieldWidth+2*U5,U5,U5,U5);
		}else if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]!=null){
			g.setColor(Color.yellow);
			g.fillRoundRect(baseX-U5,baseY-U5,fieldWidth+2*U5,U5,U5,U5);
		}
		if(bars.directionFlag[FDBBars.D_DOWN]){
			g.setColor(Color.lightGray);
			g.fillRoundRect(baseX-U5,cornerY,fieldWidth+2*U5,U5,U5,U5);
		}else if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]!=null){
			g.setColor(Color.yellow);
			g.fillRoundRect(baseX-U5,cornerY,fieldWidth+2*U5,U5,U5,U5);
		}
		if(bars.directionFlag[FDBBars.D_LEFT]){
			g.setColor(Color.lightGray);
			g.fillRoundRect(baseX-U5,baseY-U5,U5,fieldHeight+2*U5,U5,U5);
		}else if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]!=null){
			g.setColor(Color.yellow);
			g.fillRoundRect(baseX-U5,baseY-U5,U5,fieldHeight+2*U5,U5,U5);
		}
		if(bars.directionFlag[FDBBars.D_RIGHT]){
			g.setColor(Color.lightGray);
			g.fillRoundRect(cornerX,baseY-U5,U5,fieldHeight+2*U5,U5,U5);
		}else if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]!=null){
			g.setColor(Color.yellow);
			g.fillRoundRect(cornerX,baseY-U5,U5,fieldHeight+2*U5,U5,U5);
		}
		//vCf̓tB[h֏Ԃw\
		if( stateMode!=S_MOVE && stateMode!=S_WAIT ){
			String firstString,secondString;
			String thirdString=null;
			//
			if(stateMode==S_START){
				firstString="stage "+general.stageNow;
				secondString="click to start";
			}else if(stateMode==S_MOUSE_OUT){
				firstString="mouse out";
				secondString="move mouse cursol in";
			}else if(stateMode==S_REST){
				firstString="resting";
				secondString="push space key to resume";
			}else if(stateMode==S_CLEAR){
				firstString="clear";
				secondString="click to next stage";
			}else if(stateMode==S_ALL_CLEAR){
				firstString="all clear";
				if(general.premiumPage!=null){
					secondString="click to bonus page";
				}else{
					secondString="click to first stage";
				}
			}else if(stateMode==S_OVER){
				firstString="game over";
				if(general.stageContinue){
					secondString="click to restart";
					thirdString="(+shift key to continue)";
				}else{
					secondString="click to restart";
				}
			}else{
				firstString="";
				secondString="";
			}
			//
			Dimension fld=getPreferredSize();
			//
			g.setColor(Color.yellow);
			g.setFont(largeFont);
			g.drawString(firstString,baseX-U15+(int)((fld.width*2-firstString.length()*largeFont.getSize())/4),baseY-U75+(int)(fld.height/2));
			g.setFont(middleFont);
			g.drawString(secondString,baseX-U15+(int)((fld.width*2-secondString.length()*middleFont.getSize())/4),baseY-U75+(int)(fld.height/2)+largeFont.getSize());
			if(thirdString!=null){	//ʒusecondStringƓ
				g.drawString(thirdString,
						baseX-U15+(int)((fld.width*2-secondString.length()*middleFont.getSize())/4),
						baseY-U75+(int)(fld.height/2)+largeFont.getSize()+middleFont.getSize());
			}
		}
		//fobO[h̕\
		if(debugFlag){
			g.setColor(Color.yellow);
			g.setFont(smallFont);
			g.drawString("Debug Mode",baseX+smallFont.getSize(),baseY+2*smallFont.getSize());
		}
		//͂̕`
		if(repelPoint!=null){
			g.setColor(Color.white);
			//
			int dX=(int)(Math.cos(Math.atan2(ball.posY-repelPoint.y,ball.posX-repelPoint.x))*ball.radiusNow*3/2);
			int dY=(int)(Math.sin(Math.atan2(ball.posY-repelPoint.y,ball.posX-repelPoint.x))*ball.radiusNow*3/2);
			g.drawLine(baseX+repelPoint.x,baseY+repelPoint.y,baseX+ball.posX-dX,baseY+ball.posY-dY);
			g.drawLine(baseX+ball.posX-dX+dY,baseY+ball.posY-dY-dX,baseX+ball.posX-dX-dY,baseY+ball.posY-dY+dX);
			g.drawLine(baseX+ball.posX,baseY+ball.posY,
								(int)(baseX+ball.posX+ball.radiusNow*Math.cos(ball.angle)),
								(int)(baseY+ball.posY+ball.radiusNow*Math.sin(ball.angle)));
			//{[ACe
			for(int b=0;b<divideBallVec.size();b++){
				FDBBall dBall=(FDBBall)(divideBallVec.get(b));
				//
				dX=(int)(Math.cos(Math.atan2(dBall.posY-repelPoint.y,dBall.posX-repelPoint.x))*dBall.radiusNow*3/2);
				dY=(int)(Math.sin(Math.atan2(dBall.posY-repelPoint.y,dBall.posX-repelPoint.x))*dBall.radiusNow*3/2);
				g.drawLine(baseX+repelPoint.x,baseY+repelPoint.y,baseX+dBall.posX-dX,baseY+dBall.posY-dY);
				g.drawLine(baseX+dBall.posX-dX+dY,baseY+dBall.posY-dY-dX,baseX+dBall.posX-dX-dY,baseY+dBall.posY-dY+dX);
				g.drawLine(baseX+dBall.posX,baseY+dBall.posY,
									(int)(baseX+dBall.posX+dBall.radiusNow*Math.cos(dBall.angle)),
									(int)(baseY+dBall.posY+dBall.radiusNow*Math.sin(dBall.angle)));
			}
		}
	}
	//*************************************************************
	//`挴_̒
	//-------------------------------------------------------------
	//`挴_
	private void setPaintBasePoint(){
		//
		Dimension d=getPreferredSize();
		if(getWidth()<=d.width){
			baseX=U15;
			cornerX=d.width-U15;
		}else{
			baseX=U15+( (getWidth()-d.width)>>1 );
			cornerX=d.width-U15+( (getWidth()-d.width)>>1 );
		}
		if(getHeight()<=d.height){
			baseY=U75;
			cornerY=d.height-3*U15;
		}else{
			baseY=U75+( (getHeight()-d.height)>>1 );
			cornerY=d.height-3*U15+( (getHeight()-d.height)>>1 );
		}
		//ōĕ`悷̂őł͂ȂĂ
		repaint();
	}
	//œKplTCYɑ΂āApl̕\Ă镔ǂꂾTCYߏ肩Ԃ
	//it[Ă΂At[ǂꂾ߂΃XN[o[\ɂނ̔fɎgj
	public Dimension getSizeDifference(){
		//XN[o[\Ă	[pl̈]>[XN[̈pl]
		//Ȃ							[pl̈]<[XN[̈pl]
		int w=Math.min(getWidth(),scrollEdge.getWidth()-edgeMargin.width)-getPreferredSize().width;
		int h=Math.min(getHeight(),scrollEdge.getHeight()-edgeMargin.height)-getPreferredSize().height;
		return new Dimension( w , h );
	}
	//t[TCŶ߃XN[̈Ƃ̃TCY߂˂΂Ȃ
	public void setScrollEdge(JScrollPane scroll){
		scrollEdge=scroll;
		edgeMargin=new Dimension(scrollEdge.getWidth()-getWidth(),scrollEdge.getHeight()-getHeight());
		if(edgeMargin.width<=0 || edgeMargin.height<=0){	//o[\ĂĂ̒loĐȂ
			edgeMargin=new Dimension(3,3);		//炩̗RŐȂWindowsł̒lɐݒ
		}
	}
	//**********************************
	//}EXCxgP
	//----------------------------------
	public void mousePressed(MouseEvent e){    //}EX{^
		//͂
		repelPoint=getRepelPoint(e);
		setCursor(new Cursor(Cursor.HAND_CURSOR));
		sounds.loopSE(FDBSound.SE_POWER);
	}
	public void mouseReleased(MouseEvent e){	//}EX{^
		//͂
		repelPoint=null;
		if(stateMode==S_ALL_CLEAR && general.premiumPage!=null){
			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}else{
			setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
		}
		sounds.stopSE(FDBSound.SE_POWER);
	}
	public void mouseExited (MouseEvent e){	//}EXo
		//vCȂꎞ~
		if(stateMode==S_MOVE){
			stateMode=S_MOUSE_OUT;
			stopThread();		//XbhI
		}
		//repaint();
	}
	public void mouseEntered(MouseEvent e){	//}EX
		//}EXoĈꎞ~ĂȂvCĊJ
		if(stateMode==S_MOUSE_OUT){
			stateMode=S_MOVE;
			startThread();		//XbhJn
		}
		repaint();
	}
	public void mouseClicked(MouseEvent e){		//NbN
		//L[Cxg󂯎邽߂ɃtH[JXĂ
		requestFocus();
		//
		if(stateMode==S_START){
			stateMode=S_WAIT;
		}else if(stateMode==S_MOVE){
		}else if(stateMode==S_WAIT){
			stateMode=S_MOVE;
			sounds.playSE(FDBSound.SE_REFLEX);
			startThread();		//XbhJn
		}else if(stateMode==S_REST){
		}else if(stateMode==S_CLEAR){
			prepareStage(FDBGeneral.O_NEXT);
		}else if(stateMode==S_ALL_CLEAR){
			if(general.premiumPage!=null){
				parent.showPremiumPage(general.premiumPage);	//܂y[W֔
				return;
			}else{
				setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
				prepareStage(FDBGeneral.O_FIRST);
			}
		}else if(stateMode==S_OVER){
			if( e.isShiftDown() && general.stageContinue ){
				prepareStage(FDBGeneral.O_SAME);
			}else{
				prepareStage(FDBGeneral.O_FIRST);
			}
		}
		//
		repaint();
	}
	//w肳ꂽXe[W̏
	private void prepareStage(int order){
		stateMode=S_START;
		general.formatStage(order,stage);	//̒StageLoaderɃXe[W[h
		items.formatItems(stage);
		bars.formatBars(stage);
		ball.formatBall(stage);
		ball.setBallPosition(fieldWidth,fieldHeight,bars);	//BallBar̈ʒuɒ
		divideBallVec=new ArrayList<FDBBall>();
		blocks.formatBlocks(stage,fieldWidth,fieldHeight);
		imageSupply.formatImages(stage,ball,bars,parent);
	}
	//͂̌_vZ
	private Point getRepelPoint(MouseEvent e){
		//tB[h̑΍W
		Point ret=e.getPoint();
		ret.x-=baseX;
		ret.y-=baseY;
		//WtB[hɎ߂
		if(ret.x<0){
			ret.x=0;
		}else if(ret.x>=fieldWidth){
			ret.x=fieldWidth;
		}
		if(ret.y<0){
			ret.y=0;
		}else if(ret.y>=fieldHeight){
			ret.y=fieldHeight;
		}
		//
		return ret;
	}
	//**********************************
	//}EXCxgQ
	//----------------------------------
	public void mouseDragged(MouseEvent e){		//hbO
		//
		notifyBarPosition(e);
		//}EX{^͔͂̐ݒs
		repelPoint=getRepelPoint(e);
		//
		repaint();
	}
	public void mouseMoved(MouseEvent e){		//}EX𓮂
		//
		notifyBarPosition(e);
		//
		repaint();
	}
	//BarɃ}EẌʒuʒmĈʒu
	private void notifyBarPosition(MouseEvent e){
		//tB[h̑΍W
		int tmpX=e.getX()-baseX;
		int tmpY=e.getY()-baseY;
		//Bar̈ʒu𒲐
		bars.setBarsPosition(tmpX,tmpY,fieldWidth,fieldHeight);
		//ԂɂĂBall̈ʒu
		if(stateMode==S_START || stateMode==S_WAIT){
			ball.setBallPosition(fieldWidth,fieldHeight,bars);
		}
	}
	//**********************************
	//L[Cxg
	//----------------------------------
	public void keyTyped(KeyEvent e){}		//L[͂
	public void keyReleased(KeyEvent e){	//L[
		//
		switch(e.getKeyCode()){
		case KeyEvent.VK_CONTROL:	//Rg[L[΃Xs[hAbv
			speedUpFlag=false;
			break;
		default:
		}
	}
	public void keyPressed(KeyEvent e){		//L[
		//
		switch(e.getKeyCode()){
		case KeyEvent.VK_SPACE:	//Xy[XL[͈ꎞ~̐؂ւ
			if(stateMode==S_MOVE){
				stateMode=S_REST;
				stopThread();		//XbhI
			}else if(stateMode==S_REST){
				stateMode=S_MOVE;
				startThread();		//XbhJn
			}
			break;
		case KeyEvent.VK_CONTROL:	//Rg[L[̊Ԃ̓Xs[hAbv
			speedUpFlag=true;
			break;
		default:
		}
		//fobO[h
		if(debugFlag){
			switch(e.getKeyCode()){
			case KeyEvent.VK_C:	//vCɁucvL[ƁÃXe[WNA[
				debugStageClear();
				return;
			case KeyEvent.VK_S:	//NAʂŁusvL[ƁAŏIXe[W
				debugLastStage();
				return;
			default:
			}
		}
		//
		//repaint();
	}
	//***************************************************************
	//debug[hŎgiMenuĂ΂̂Ń\bhj
	//---------------------------------------------------------------
	public void debugStageClear(){
		if(stateMode==S_MOVE || stateMode==S_MOUSE_OUT){
			if(general.checkLastStage()){
				stateMode=S_ALL_CLEAR;
				sounds.playSE(FDBSound.SE_ALLCLEAR);
				if(general.premiumPage!=null){
					setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
				}
				stopThread();		//XbhI
			}else{
				stateMode=S_CLEAR;
				sounds.playSE(FDBSound.SE_CLEAR);
				stopThread();		//XbhI
			}
			//
			//repaint();
		}
	}
	public void debugLastStage(){
		if(stateMode==S_CLEAR){
			prepareStage(FDBGeneral.O_FINAL);
			//
			repaint();
		}
	}
	//*************************************************************
	//R|[lgCxgitB[h̑傫ύX擾j
	//-------------------------------------------------------------
	public void componentHidden(ComponentEvent arg0) {
	}
	public void componentMoved(ComponentEvent arg0) {
	}
	//pl̃TCYςΕ`挴_Đݒ
	public void componentResized(ComponentEvent e) {
		setPaintBasePoint();
	}
	public void componentShown(ComponentEvent arg0) {
	}
	//***************************************************************
	//Xbh
	//---------------------------------------------------------------
	private void startThread(){
		threadStop=false;
		//Xbh̊Jn
		moveThread=new Thread(this);
		moveThread.start();
	}
	private void stopThread(){
		threadStop=true;
	}
	public void run() {
		//[v
		while (true){
			//:::::Item̈ړƎԌo:::::
			items.timePassBy(fieldWidth,fieldHeight,ball,bars,blocks,general,sounds,this);
			//:::::
			try{
				if(speedUpFlag){
					Thread.sleep(REPAINT_INTERVAL>>1);	//Rg[L[̓Xs[h2{
				}else{
					Thread.sleep(REPAINT_INTERVAL);	//
				}
			}catch (InterruptedException e){
				return;
			}
			//:::::Item(ball increase)Ball:::::
			for(int b=0;b<divideBallVec.size();b++){
				FDBBall dBall=(FDBBall)(divideBallVec.get(b));
				//Ball}EXJ[\ւ̔͂󂯂ĕς
				dBall.receiveRepelPower(repelPoint);
				//Ball𓮂ē蔻Aʂ󂯎
				int ballMoveResult=dBall.move(fieldWidth,fieldHeight,blocks,bars,general,items,sounds);
				if(ballMoveResult!=FDBBall.R_CONTINUE){	//
					if( ballMoveResult==FDBBall.R_BALL_OUT || ballMoveResult==FDBBall.R_GAME_OVER ){
						divideBallVec.remove(b);	//Oɏoz񂩂폜
					}else if(ballMoveResult==FDBBall.R_STAGE_CLEAR){
						if(general.checkLastStage()){
							stateMode=S_ALL_CLEAR;
							sounds.playSE(FDBSound.SE_ALLCLEAR);
							if(general.premiumPage!=null){
								setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
							}
						}else{
							stateMode=S_CLEAR;
							sounds.playSE(FDBSound.SE_CLEAR);
						}
						//
						repaint();
						return;		//XbhI
					}
				}
			}
			//:::::Ball̈ړƓ蔻:::::
			//Ball}EXJ[\ւ̔͂󂯂ĕς
			ball.receiveRepelPower(repelPoint);
			//Ball𓮂ē蔻Aʂ󂯎
			int ballMoveResult=ball.move(fieldWidth,fieldHeight,blocks,bars,general,items,sounds);
			if(ballMoveResult!=FDBBall.R_CONTINUE){	//
				if(divideBallVec.size()<=0){	//Item(ball increase)̃{[Ȃ
					if(ballMoveResult==FDBBall.R_BALL_OUT){
						stateMode=S_WAIT;
						sounds.playSE(FDBSound.SE_OUT);
						ball.setBallPosition(fieldWidth,fieldHeight,bars);
					}else if(ballMoveResult==FDBBall.R_STAGE_CLEAR){
						if(general.checkLastStage()){
							stateMode=S_ALL_CLEAR;
							sounds.playSE(FDBSound.SE_ALLCLEAR);
							if(general.premiumPage!=null){
								setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
							}
						}else{
							stateMode=S_CLEAR;
							sounds.playSE(FDBSound.SE_CLEAR);
						}
					}else if(ballMoveResult==FDBBall.R_GAME_OVER){
						stateMode=S_OVER;
						sounds.playSE(FDBSound.SE_OVER);
					}
					//
					repaint();
					return;		//XbhI
				}else{	//Item(ball increase)̃{[
					if( ballMoveResult==FDBBall.R_BALL_OUT || ballMoveResult==FDBBall.R_GAME_OVER ){
						ball=(FDBBall)(divideBallVec.get(0));	//BallOɏoItem玝Ă
						divideBallVec.remove(0);
					}else if(ballMoveResult==FDBBall.R_STAGE_CLEAR){
						if(general.checkLastStage()){
							stateMode=S_ALL_CLEAR;
							sounds.playSE(FDBSound.SE_ALLCLEAR);
							if(general.premiumPage!=null){
								setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
							}
						}else{
							stateMode=S_CLEAR;
							sounds.playSE(FDBSound.SE_CLEAR);
						}
						//
						repaint();
						return;		//XbhI
					}
				}
			}
			//
			repaint();	//ĕ`
			//
			//-----------------------------------------XbhItOmF
			if(threadStop){
				return;
			}
		}
	}
}
